#include "Chunk.h"

int Chunk::rebuiltThisFrame;
int Chunk::updates;
int Chunk::Dirt;
int Chunk::Cobblestone;
bool Chunk::initDone = false;
Tessellator Chunk::TESSELLATOR;

    /**
     * Render all tiles in this chunk
     *
     * @param layer The layer of the chunk (For shadows)
     */
void Chunk::rebuild(int layer) {
    if (rebuiltThisFrame == 2) {
        // Rebuild limit reached for this frame
        return;
    }

    // Update global stats
    updates++;
    rebuiltThisFrame++;

    // Mark chunk as no longer dirty
    dirty = false;

    // Setup tile rendering
    glNewList(lists + layer, GL_COMPILE);
    glEnable(GL_TEXTURE_2D);
    TESSELLATOR.init();

    // For each tile in this chunk
    for (int x = minX; x < maxX; ++x) {
        for (int y = minY; y < maxY; ++y) {
            for (int z = minZ; z < maxZ; ++z) {
                // Is a tile at this location?
                if (level->isTile(x, y, z)) {
                    int id = (y != level->depth * 2 / 3) ? 1 : 0;

                    if (id == 0) {
                        // Render the grass tile
                        glBindTexture(GL_TEXTURE_2D, Dirt);
                        Tile::grass.render(TESSELLATOR, *level, layer, x, y, z);
                    } else {
                        // Render the cobblestone tile
                        glBindTexture(GL_TEXTURE_2D, Cobblestone);
                        Tile::rock.render(TESSELLATOR, *level, layer, x, y, z);
                    }
                }
            }
        }
    }

    // Finish tile rendering
    TESSELLATOR.flush();
    glDisable(GL_TEXTURE_2D);
    glEndList();
}
