#ifndef LEVELLISTENER_H_INCLUDED
#define LEVELLISTENER_H_INCLUDED

class LevelListener {
    public :
    /**
     * Gets called when a tile changed it's light level
     *
     * @param x    Tile position x
     * @param z    Tile position z
     * @param minY Minimum tile position Y (Start range)
     * @param maxY Maximum tile position Y (End range)
     */
    virtual void lightColumnChanged(int x, int z, int minY, int maxY) {(void) x;(void) z;(void) minY;(void) maxY;}

    /**
     * Gets called when a tile changed it's type
     *
     * @param x Tile position x
     * @param y Tile position y
     * @param z Tile position z
     */
    virtual void tileChanged(int x, int y, int z) {(void) x;(void) y;(void) z;}

    /**
     * Gets called when the entire level changed
     */
    virtual void allChanged() {}

    virtual ~LevelListener() {}
};

#endif // LEVELLISTENER_H_INCLUDED
