#ifndef TEXTURES_H_INCLUDED
#define TEXTURES_H_INCLUDED

#include <GL/gl.h>
#include <GL/glu.h>
#include <iostream>
#include <fstream>

using namespace std;

class Textures {

  private :
    static int lastId;

  public :
    static int loadTexture(const char *resourceName, int mode);

    /**
     * Bind the texture to OpenGL using the id from {@link #loadTexture(String, int)}
     *
     * @param id Texture id
     */
   	static void bind(int id) {
        if (id != lastId) {
            glBindTexture(GL_TEXTURE_2D, id);
            lastId = id;
        }
    }
};

#endif // TEXTURES_H_INCLUDED
