#include "Timer.h"

    /**
     * This function calculates the amount of ticks required to reach the ticksPerSecond.
     * Call this function in the main render loop of the game
     */
void Timer::advanceTime() {
    clock_t now = clock();
    clock_t passedNs = now - lastTime;

    // Store nano time of this update
    lastTime = now;

    // Maximum and minimum
    passedNs = max(0L, passedNs);
    passedNs = min(MAX_NS_PER_UPDATE, passedNs);

    // Calculate fps
    fps = NS_PER_SECOND / passedNs;

    // Calculate passed time and ticks
    passedTime += passedNs * timeScale * ticksPerSecond / NS_PER_SECOND;
    ticks = (int) passedTime;

    // Maximum ticks per update
    ticks = min(MAX_TICKS_PER_UPDATE, ticks);

    // Calculate the overflow of the current tick
    passedTime -= ticks;
    partialTicks = passedTime;
}
